/**
 * This file was auto-generated by mofcomp -j version 1.0.0 on Wed Jan 12
 * 09:21:06 CET 2011.
 */

package org.opennaas.extensions.router.model;

import java.io.Serializable;

/**
 * This Class contains accessor and mutator methods for all properties defined in the CIM class BGPAttributes as well as methods comparable to the
 * invokeMethods defined for this class. This Class implements the BGPAttributesBean Interface. The CIM class BGPAttributes is described as follows:
 * 
 * This class defines the BGP Attributes, that can be used to affect routing decisions. BGPAttributes are specific to a given AutonomousSystem that
 * contains it. Hence, the keys of the AutonomousSystem are propagated to this class.
 */
public class BGPAttributes extends LogicalElement implements Serializable {

	/**
	 * This constructor creates a BGPAttributesBeanImpl Class which implements the BGPAttributesBean Interface, and encapsulates the CIM class
	 * BGPAttributes in a Java Bean. The CIM class BGPAttributes is described as follows:
	 * 
	 * This class defines the BGP Attributes, that can be used to affect routing decisions. BGPAttributes are specific to a given AutonomousSystem
	 * that contains it. Hence, the keys of the AutonomousSystem are propagated to this class.
	 */
	public BGPAttributes() {
	};

	/**
	 * The following constants are defined for use with the ValueMap/Values qualified property systemCreationClassName.
	 */
	private String	systemCreationClassName;

	/**
	 * This method returns the BGPAttributes.systemCreationClassName property value. This property is described as follows:
	 * 
	 * The scoping AutonomousSystem's CreationClassName.
	 * 
	 * @return String current systemCreationClassName property value
	 * @exception Exception
	 */
	public String getSystemCreationClassName() {

		return this.systemCreationClassName;
	} // getSystemCreationClassName

	/**
	 * This method sets the BGPAttributes.systemCreationClassName property value. This property is described as follows:
	 * 
	 * The scoping AutonomousSystem's CreationClassName.
	 * 
	 * @param String
	 *            new systemCreationClassName property value
	 * @exception Exception
	 */
	public void setSystemCreationClassName(String systemCreationClassName) {

		this.systemCreationClassName = systemCreationClassName;
	} // setSystemCreationClassName

	/**
	 * The following constants are defined for use with the ValueMap/Values qualified property systemName.
	 */
	private String	systemName;

	/**
	 * This method returns the BGPAttributes.systemName property value. This property is described as follows:
	 * 
	 * The scoping AutonomousSystem's Name.
	 * 
	 * @return String current systemName property value
	 * @exception Exception
	 */
	public String getSystemName() {

		return this.systemName;
	} // getSystemName

	/**
	 * This method sets the BGPAttributes.systemName property value. This property is described as follows:
	 * 
	 * The scoping AutonomousSystem's Name.
	 * 
	 * @param String
	 *            new systemName property value
	 * @exception Exception
	 */
	public void setSystemName(String systemName) {

		this.systemName = systemName;
	} // setSystemName

	/**
	 * The following constants are defined for use with the ValueMap/Values qualified property version.
	 */
	private String	version;

	/**
	 * This method returns the BGPAttributes.version property value. This property is described as follows:
	 * 
	 * This defines the version of the BGP protocol.
	 * 
	 * @return String current version property value
	 * @exception Exception
	 */
	public String getVersion() {

		return this.version;
	} // getVersion

	/**
	 * This method sets the BGPAttributes.version property value. This property is described as follows:
	 * 
	 * This defines the version of the BGP protocol.
	 * 
	 * @param String
	 *            new version property value
	 * @exception Exception
	 */
	public void setVersion(String version) {

		this.version = version;
	} // setVersion

	/**
	 * The following constants are defined for use with the ValueMap/Values qualified property localPreference.
	 */
	private int	localPreference;

	/**
	 * This method returns the BGPAttributes.localPreference property value. This property is described as follows:
	 * 
	 * This defines the priority, or preference, of a route, in order to better compare it with other routes for the same destination. Higher values
	 * indicate a higher preference for a route.
	 * 
	 * @return int current localPreference property value
	 * @exception Exception
	 */
	public int getLocalPreference() {

		return this.localPreference;
	} // getLocalPreference

	/**
	 * This method sets the BGPAttributes.localPreference property value. This property is described as follows:
	 * 
	 * This defines the priority, or preference, of a route, in order to better compare it with other routes for the same destination. Higher values
	 * indicate a higher preference for a route.
	 * 
	 * @param int new localPreference property value
	 * @exception Exception
	 */
	public void setLocalPreference(int localPreference) {

		this.localPreference = localPreference;
	} // setLocalPreference

	/**
	 * The following constants are defined for use with the ValueMap/Values qualified property aSPath.
	 */
	private String	aSPath;

	/**
	 * This method returns the BGPAttributes.aSPath property value. This property is described as follows:
	 * 
	 * This attribute is a sequences of the AS numbers through which routing information carried in this UPDATE message has passed. The components of
	 * this list can be AS_SETs or AS_SEQUENCEs.
	 * 
	 * @return String current aSPath property value
	 * @exception Exception
	 */
	public String getASPath() {

		return this.aSPath;
	} // getASPath

	/**
	 * This method sets the BGPAttributes.aSPath property value. This property is described as follows:
	 * 
	 * This attribute is a sequences of the AS numbers through which routing information carried in this UPDATE message has passed. The components of
	 * this list can be AS_SETs or AS_SEQUENCEs.
	 * 
	 * @param String
	 *            new aSPath property value
	 * @exception Exception
	 */
	public void setASPath(String aSPath) {

		this.aSPath = aSPath;
	} // setASPath

	/**
	 * The following constants are defined for use with the ValueMap/Values qualified property asSet.
	 */
	private String	asSet;

	/**
	 * This method returns the BGPAttributes.asSet property value. This property is described as follows:
	 * 
	 * This is the set of all elements contained in all specific paths that are being summarized, so that those attributes will remain available to
	 * the routing decision process.
	 * 
	 * @return String current asSet property value
	 * @exception Exception
	 */
	public String getAsSet() {

		return this.asSet;
	} // getAsSet

	/**
	 * This method sets the BGPAttributes.asSet property value. This property is described as follows:
	 * 
	 * This is the set of all elements contained in all specific paths that are being summarized, so that those attributes will remain available to
	 * the routing decision process.
	 * 
	 * @param String
	 *            new asSet property value
	 * @exception Exception
	 */
	public void setAsSet(String asSet) {

		this.asSet = asSet;
	} // setAsSet

	/**
	 * The following constants are defined for use with the ValueMap/Values qualified property nextHop.
	 */
	private String	nextHop;

	/**
	 * This method returns the BGPAttributes.nextHop property value. This property is described as follows:
	 * 
	 * This attribute defines the IP address of the border router that should be used as the next hop to the destinations listed in the UPDATE
	 * message.
	 * 
	 * @return String current nextHop property value
	 * @exception Exception
	 */
	public String getNextHop() {

		return this.nextHop;
	} // getNextHop

	/**
	 * This method sets the BGPAttributes.nextHop property value. This property is described as follows:
	 * 
	 * This attribute defines the IP address of the border router that should be used as the next hop to the destinations listed in the UPDATE
	 * message.
	 * 
	 * @param String
	 *            new nextHop property value
	 * @exception Exception
	 */
	public void setNextHop(String nextHop) {

		this.nextHop = nextHop;
	} // setNextHop

	/**
	 * The following constants are defined for use with the ValueMap/Values qualified property nextHopSelf.
	 */
	private String	nextHopSelf;

	/**
	 * This method returns the BGPAttributes.nextHopSelf property value. This property is described as follows:
	 * 
	 * This defines the next hop to be the IP address of the border IBGP neighbor.
	 * 
	 * @return String current nextHopSelf property value
	 * @exception Exception
	 */
	public String getNextHopSelf() {

		return this.nextHopSelf;
	} // getNextHopSelf

	/**
	 * This method sets the BGPAttributes.nextHopSelf property value. This property is described as follows:
	 * 
	 * This defines the next hop to be the IP address of the border IBGP neighbor.
	 * 
	 * @param String
	 *            new nextHopSelf property value
	 * @exception Exception
	 */
	public void setNextHopSelf(String nextHopSelf) {

		this.nextHopSelf = nextHopSelf;
	} // setNextHopSelf

	/**
	 * The following constants are defined for use with the ValueMap/Values qualified property mED.
	 */
	private long	mED;

	/**
	 * This method returns the BGPAttributes.mED property value. This property is described as follows:
	 * 
	 * This is used on external (e.g., inter-AS) links to indicate which is the preferred entry point into an AS, when that AS has multiple entry
	 * points. Lower MED values have preference.
	 * 
	 * @return long current mED property value
	 * @exception Exception
	 */
	public long getMED() {

		return this.mED;
	} // getMED

	/**
	 * This method sets the BGPAttributes.mED property value. This property is described as follows:
	 * 
	 * This is used on external (e.g., inter-AS) links to indicate which is the preferred entry point into an AS, when that AS has multiple entry
	 * points. Lower MED values have preference.
	 * 
	 * @param long new mED property value
	 * @exception Exception
	 */
	public void setMED(long mED) {

		this.mED = mED;
	} // setMED

	/**
	 * The following constants are defined for use with the ValueMap/Values qualified property bGPCommunityValue.
	 */
	private long	bGPCommunityValue;

	/**
	 * This method returns the BGPAttributes.bGPCommunityValue property value. This property is described as follows:
	 * 
	 * This defines a group of destinations that share a similar property. Communities are not restricted to a single AS, and can span multiple ASs.
	 * This attribute is used to simplify routing policies by basing policies on a logical value, as opposed to an IP address or an AS number.
	 * 
	 * @return long current bGPCommunityValue property value
	 * @exception Exception
	 */
	public long getBGPCommunityValue() {

		return this.bGPCommunityValue;
	} // getBGPCommunityValue

	/**
	 * This method sets the BGPAttributes.bGPCommunityValue property value. This property is described as follows:
	 * 
	 * This defines a group of destinations that share a similar property. Communities are not restricted to a single AS, and can span multiple ASs.
	 * This attribute is used to simplify routing policies by basing policies on a logical value, as opposed to an IP address or an AS number.
	 * 
	 * @param long new bGPCommunityValue property value
	 * @exception Exception
	 */
	public void setBGPCommunityValue(long bGPCommunityValue) {

		this.bGPCommunityValue = bGPCommunityValue;
	} // setBGPCommunityValue

	/**
	 * The following constants are defined for use with the ValueMap/Values qualified property atomicAggregate.
	 */
	private boolean	atomicAggregate;

	/**
	 * This method returns the BGPAttributes.atomicAggregate property value. This property is described as follows:
	 * 
	 * This property is set to TRUE if there are overlapping routes, and a less-specific route is selected instead of a more specific one (e.g., a
	 * system propagates an aggregate that causes loss of information). The value is set to FALSE if a less-specific route is NOT selected.
	 * 
	 * @return boolean current atomicAggregate property value
	 * @exception Exception
	 */
	public boolean isAtomicAggregate() {

		return this.atomicAggregate;
	} // getAtomicAggregate

	/**
	 * This method sets the BGPAttributes.atomicAggregate property value. This property is described as follows:
	 * 
	 * This property is set to TRUE if there are overlapping routes, and a less-specific route is selected instead of a more specific one (e.g., a
	 * system propagates an aggregate that causes loss of information). The value is set to FALSE if a less-specific route is NOT selected.
	 * 
	 * @param boolean new atomicAggregate property value
	 * @exception Exception
	 */
	public void setAtomicAggregate(boolean atomicAggregate) {

		this.atomicAggregate = atomicAggregate;
	} // setAtomicAggregate

	/**
	 * The following constants are defined for use with the ValueMap/Values qualified property aggregator.
	 */
	private String	aggregator;

	/**
	 * This method returns the BGPAttributes.aggregator property value. This property is described as follows:
	 * 
	 * This specifies the AS and IP address of the router that has generated an aggregate.
	 * 
	 * @return String current aggregator property value
	 * @exception Exception
	 */
	public String getAggregator() {

		return this.aggregator;
	} // getAggregator

	/**
	 * This method sets the BGPAttributes.aggregator property value. This property is described as follows:
	 * 
	 * This specifies the AS and IP address of the router that has generated an aggregate.
	 * 
	 * @param String
	 *            new aggregator property value
	 * @exception Exception
	 */
	public void setAggregator(String aggregator) {

		this.aggregator = aggregator;
	} // setAggregator

	/**
	 * The following constants are defined for use with the ValueMap/Values qualified property Origin.
	 */

	public enum Origin {
		IGP,
		EGP,
		INCOMPLETE
	}

	private Origin	origin;

	/**
	 * This method returns the BGPAttributes.origin property value. This property is described as follows:
	 * 
	 * This is generated by the AS that originates the routing information. There are three types of origins - IGP, EGP, and INCOMPLETE. These
	 * correspond to whether the information was learned internally in the AS, externally via an EGP, or by some other means.
	 * 
	 * @return int current origin property value
	 * @exception Exception
	 */
	public Origin getOrigin() {

		return this.origin;
	} // getOrigin

	/**
	 * This method sets the BGPAttributes.origin property value. This property is described as follows:
	 * 
	 * This is generated by the AS that originates the routing information. There are three types of origins - IGP, EGP, and INCOMPLETE. These
	 * correspond to whether the information was learned internally in the AS, externally via an EGP, or by some other means.
	 * 
	 * @param int new origin property value
	 * @exception Exception
	 */
	public void setOrigin(Origin origin) {

		this.origin = origin;
	} // setOrigin

	/**
	 * The following constants are defined for use with the ValueMap/Values qualified property originatorID.
	 */
	private String	originatorID;

	/**
	 * This method returns the BGPAttributes.originatorID property value. This property is described as follows:
	 * 
	 * This is the router ID for the ORIGIN attribute.
	 * 
	 * @return String current originatorID property value
	 * @exception Exception
	 */
	public String getOriginatorID() {

		return this.originatorID;
	} // getOriginatorID

	/**
	 * This method sets the BGPAttributes.originatorID property value. This property is described as follows:
	 * 
	 * This is the router ID for the ORIGIN attribute.
	 * 
	 * @param String
	 *            new originatorID property value
	 * @exception Exception
	 */
	public void setOriginatorID(String originatorID) {

		this.originatorID = originatorID;
	} // setOriginatorID

} // Class BGPAttributes
