/**
 * This file was auto-generated by mofcomp -j version 1.0.0 on Wed Jan 12
 * 09:21:06 CET 2011.
 */

package org.opennaas.extensions.router.model;

import java.io.Serializable;

/**
 * This Class contains accessor and mutator methods for all properties defined in the CIM class BGPService as well as methods comparable to the
 * invokeMethods defined for this class. This Class implements the BGPServiceBean Interface. The CIM class BGPService is described as follows:
 * 
 * This class is used to represent the basic operation of BGP. It is derived from RouteCalculationService, the superclass of all routing protocols.
 */
public class BGPService extends RouteCalculationService implements
		Serializable {

	/**
	 * This constructor creates a BGPServiceBeanImpl Class which implements the BGPServiceBean Interface, and encapsulates the CIM class BGPService in
	 * a Java Bean. The CIM class BGPService is described as follows:
	 * 
	 * This class is used to represent the basic operation of BGP. It is derived from RouteCalculationService, the superclass of all routing
	 * protocols.
	 */
	public BGPService() {
	};

	/**
	 * The following constants are defined for use with the ValueMap/Values qualified property bGPVersion.
	 */
	private short	bGPVersion;

	/**
	 * This method returns the BGPService.bGPVersion property value. This property is described as follows:
	 * 
	 * The BGPVersion property defines the version of BGP that this router is using. This is part of the BGP peer negotiation process).
	 * 
	 * @return short current bGPVersion property value
	 * @exception Exception
	 */
	public short getBGPVersion() {

		return this.bGPVersion;
	} // getBGPVersion

	/**
	 * This method sets the BGPService.bGPVersion property value. This property is described as follows:
	 * 
	 * The BGPVersion property defines the version of BGP that this router is using. This is part of the BGP peer negotiation process).
	 * 
	 * @param short new bGPVersion property value
	 * @exception Exception
	 */
	public void setBGPVersion(short bGPVersion) {

		this.bGPVersion = bGPVersion;
	} // setBGPVersion

	/**
	 * The following constants are defined for use with the ValueMap/Values qualified property LastErrorCode.
	 */

	public enum LastErrorCode {
		NONE,
		MESSAGE_HEADER_ERROR,
		OPEN_MESSAGE_ERROR,
		UPDATE_MESSAGE_ERROR,
		HOLD_TIMER_EXPIRED,
		FINITE_STATE_MACHINE_ERROR,
		CEASE
	}

	private LastErrorCode	lastErrorCode;

	/**
	 * This method returns the BGPService.lastErrorCode property value. This property is described as follows:
	 * 
	 * BGP sends errors using a NOTIFICATION message. This message contains an error code, an error subcode, and error data. The error code defines
	 * the type of the notification. The 'Cease' error is for all fatal errors that are not one of the other five types of errors. For several of the
	 * errors, subcode information is also enumerated in other properties of this class.
	 * 
	 * @return int current lastErrorCode property value
	 * @exception Exception
	 */
	public LastErrorCode getLastErrorCode() {

		return this.lastErrorCode;
	} // getLastErrorCode

	/**
	 * This method sets the BGPService.lastErrorCode property value. This property is described as follows:
	 * 
	 * BGP sends errors using a NOTIFICATION message. This message contains an error code, an error subcode, and error data. The error code defines
	 * the type of the notification. The 'Cease' error is for all fatal errors that are not one of the other five types of errors. For several of the
	 * errors, subcode information is also enumerated in other properties of this class.
	 * 
	 * @param int new lastErrorCode property value
	 * @exception Exception
	 */
	public void setLastErrorCode(LastErrorCode lastErrorCode) {

		this.lastErrorCode = lastErrorCode;
	} // setLastErrorCode

	/**
	 * The following constants are defined for use with the ValueMap/Values qualified property LastMessageErrorSubCode.
	 */

	public enum LastMessageErrorSubCode {
		NONE,
		CONNECTION_NOT_SYNCHRONIZED,
		BAD_MESSAGE_LENGTH,
		BAD_MESSAGE_TYPE
	}

	private LastMessageErrorSubCode	lastMessageErrorSubCode;

	/**
	 * This method returns the BGPService.lastMessageErrorSubCode property value. This property is described as follows:
	 * 
	 * This defines the BGP error subcode for message header errors (LastErrorCode = 1). If LastErrorCode is any other value, then this property
	 * should be set to NULL.
	 * 
	 * @return int current lastMessageErrorSubCode property value
	 * @exception Exception
	 */
	public LastMessageErrorSubCode getLastMessageErrorSubCode() {

		return this.lastMessageErrorSubCode;
	} // getLastMessageErrorSubCode

	/**
	 * This method sets the BGPService.lastMessageErrorSubCode property value. This property is described as follows:
	 * 
	 * This defines the BGP error subcode for message header errors (LastErrorCode = 1). If LastErrorCode is any other value, then this property
	 * should be set to NULL.
	 * 
	 * @param int new lastMessageErrorSubCode property value
	 * @exception Exception
	 */
	public void setLastMessageErrorSubCode(LastMessageErrorSubCode
			lastMessageErrorSubCode) {

		this.lastMessageErrorSubCode = lastMessageErrorSubCode;
	} // setLastMessageErrorSubCode

	/**
	 * The following constants are defined for use with the ValueMap/Values qualified property LastOpenErrorSubCode.
	 */

	public enum LastOpenErrorSubCode {
		NONE,
		UNSUPPORTED_VERSION_NUMBER,
		BAD_PEER_AS,
		BAD_BGP_IDENTIFIER,
		UNSUPPORTED_OPTIONAL_PARAMETER,
		AUTHENTICATION_FAILURE,
		UNACCEPTABLE_HOLD_TIME
	}

	private LastOpenErrorSubCode	lastOpenErrorSubCode;

	/**
	 * This method returns the BGPService.lastOpenErrorSubCode property value. This property is described as follows:
	 * 
	 * This defines the BGP error subcode for OPEN message errors (LastErrorCode = 2). If LastErrorCode is any other value, then this property should
	 * be set to NULL.
	 * 
	 * @return int current lastOpenErrorSubCode property value
	 * @exception Exception
	 */
	public LastOpenErrorSubCode getLastOpenErrorSubCode() {

		return this.lastOpenErrorSubCode;
	} // getLastOpenErrorSubCode

	/**
	 * This method sets the BGPService.lastOpenErrorSubCode property value. This property is described as follows:
	 * 
	 * This defines the BGP error subcode for OPEN message errors (LastErrorCode = 2). If LastErrorCode is any other value, then this property should
	 * be set to NULL.
	 * 
	 * @param int new lastOpenErrorSubCode property value
	 * @exception Exception
	 */
	public void setLastOpenErrorSubCode(LastOpenErrorSubCode
			lastOpenErrorSubCode) {

		this.lastOpenErrorSubCode = lastOpenErrorSubCode;
	} // setLastOpenErrorSubCode

	/**
	 * The following constants are defined for use with the ValueMap/Values qualified property LastUpdateErrorSubCode.
	 */

	public enum LastUpdateErrorSubCode {
		NONE,
		MALFORMED_ATTRIBUTE_LIST,
		UNRECOGNIZED_WELL_KNOWN_ATTRIBUTE,
		MISSING_WELL_KNOWN_ATTRIBUTE,
		ATTRIBUTE_FLAGS_ERROR,
		ATTRIBUTE_LENGTH_ERROR,
		INVALID_ORIGIN_ATTRIBUTE,
		AS_ROUTING_LOOP,
		INVALID_NEXT_HOP_ATTRIBUTE,
		OPTIONAL_ATTRIBUTE_ERROR,
		INVALID_NETWORK_FIELD,
		MALFORMED_AS_PATH
	}

	private LastUpdateErrorSubCode	lastUpdateErrorSubCode;

	/**
	 * This method returns the BGPService.lastUpdateErrorSubCode property value. This property is described as follows:
	 * 
	 * This defines the BGP error subcode for UPDATE message errors (LastErrorCode = 3). If LastErrorCode is any other value, then this property
	 * should be set to NULL.
	 * 
	 * @return int current lastUpdateErrorSubCode property value
	 * @exception Exception
	 */
	public LastUpdateErrorSubCode getLastUpdateErrorSubCode() {

		return this.lastUpdateErrorSubCode;
	} // getLastUpdateErrorSubCode

	/**
	 * This method sets the BGPService.lastUpdateErrorSubCode property value. This property is described as follows:
	 * 
	 * This defines the BGP error subcode for UPDATE message errors (LastErrorCode = 3). If LastErrorCode is any other value, then this property
	 * should be set to NULL.
	 * 
	 * @param int new lastUpdateErrorSubCode property value
	 * @exception Exception
	 */
	public void setLastUpdateErrorSubCode(LastUpdateErrorSubCode
			lastUpdateErrorSubCode) {

		this.lastUpdateErrorSubCode = lastUpdateErrorSubCode;
	} // setLastUpdateErrorSubCode

} // Class BGPService
