/**
 * This file was auto-generated by mofcomp -j version 1.0.0 on Wed Jan 12
 * 09:21:06 CET 2011.
 */

package org.opennaas.extensions.router.model;

import java.io.Serializable;

/**
 * This Class contains accessor and mutator methods for all properties defined in the CIM class OSPFProtocolEndpointBase as well as methods comparable
 * to the invokeMethods defined for this class. This Class implements the OSPFProtocolEndpointBaseBean Interface. The CIM class
 * OSPFProtocolEndpointBase is described as follows:
 * 
 * Base class for OSPF protocol endpoints, defining several general properties.
 */
public class OSPFProtocolEndpointBase extends ProtocolEndpoint implements
		Serializable {

	/**
	 * 
	 */
	private static final long	serialVersionUID	= -6537017184553228369L;

	/* EndpointInArea */
	/**
	 * 
	 * @return OSPFArea associated to this OSPFProtocolEndpointBase through EndpointInArea aggregation.
	 */
	public OSPFArea getOSPFArea() {
		return (OSPFArea) this.getFirstFromAssociatedElementByType(EndpointInArea.class);
	}

	/**
	 * Associates this OSPFProtocolEndpointBase with ospfArea through EndpointInArea aggregation
	 */
	public void setOSPFArea(OSPFArea ospfArea) {
		if (ospfArea != null)
			EndpointInArea.link(ospfArea, this);
	}

	/**
	 * This constructor creates a OSPFProtocolEndpointBaseBeanImpl Class which implements the OSPFProtocolEndpointBaseBean Interface, and encapsulates
	 * the CIM class OSPFProtocolEndpointBase in a Java Bean. The CIM class OSPFProtocolEndpointBase is described as follows:
	 * 
	 * Base class for OSPF protocol endpoints, defining several general properties.
	 */
	public OSPFProtocolEndpointBase() {
	};

	/**
	 * The following constants are defined for use with the ValueMap/Values qualified property transitDelay.
	 */
	private int	transitDelay;

	/**
	 * This method returns the OSPFProtocolEndpointBase.transitDelay property value. This property is described as follows:
	 * 
	 * Estimated delay, in seconds that it takes to transmit a Link State Update Packet over this interface, see C.3 in RFC 2328.
	 * 
	 * @return int current transitDelay property value
	 * @exception Exception
	 */
	public int getTransitDelay() {

		return this.transitDelay;
	} // getTransitDelay

	/**
	 * This method sets the OSPFProtocolEndpointBase.transitDelay property value. This property is described as follows:
	 * 
	 * Estimated delay, in seconds that it takes to transmit a Link State Update Packet over this interface, see C.3 in RFC 2328.
	 * 
	 * @param int new transitDelay property value
	 * @exception Exception
	 */
	public void setTransitDelay(int transitDelay) {

		this.transitDelay = transitDelay;
	} // setTransitDelay

	/**
	 * The following constants are defined for use with the ValueMap/Values qualified property retransmitInterval.
	 */
	private int	retransmitInterval;

	/**
	 * This method returns the OSPFProtocolEndpointBase.retransmitInterval property value. This property is described as follows:
	 * 
	 * The number of seconds between LSA (Link State Advertisement) retransmissions, see C.3 in RFC 2328.
	 * 
	 * @return int current retransmitInterval property value
	 * @exception Exception
	 */
	public int getRetransmitInterval() {

		return this.retransmitInterval;
	} // getRetransmitInterval

	/**
	 * This method sets the OSPFProtocolEndpointBase.retransmitInterval property value. This property is described as follows:
	 * 
	 * The number of seconds between LSA (Link State Advertisement) retransmissions, see C.3 in RFC 2328.
	 * 
	 * @param int new retransmitInterval property value
	 * @exception Exception
	 */
	public void setRetransmitInterval(int retransmitInterval) {

		this.retransmitInterval = retransmitInterval;
	} // setRetransmitInterval

	/**
	 * The following constants are defined for use with the ValueMap/Values qualified property AuthType.
	 */

	public enum AuthType {
		OTHER,
		NULL_AUTHENTICATION,
		SIMPLE_PASSWORD,
		CRYPTOGRAPHIC_AUTHENTICATION
	}

	private AuthType	authType;

	/**
	 * This method returns the OSPFProtocolEndpointBase.authType property value. This property is described as follows:
	 * 
	 * Identifies the authentication procedure to be used on the attached network, see C.3 in RFC 2328.
	 * 
	 * @return int current authType property value
	 * @exception Exception
	 */
	public AuthType getAuthType() {

		return this.authType;
	} // getAuthType

	/**
	 * This method sets the OSPFProtocolEndpointBase.authType property value. This property is described as follows:
	 * 
	 * Identifies the authentication procedure to be used on the attached network, see C.3 in RFC 2328.
	 * 
	 * @param int new authType property value
	 * @exception Exception
	 */
	public void setAuthType(AuthType authType) {

		this.authType = authType;
	} // setAuthType

	/**
	 * The following constants are defined for use with the ValueMap/Values qualified property otherAuthType.
	 */
	private String	otherAuthType;

	/**
	 * This method returns the OSPFProtocolEndpointBase.otherAuthType property value. This property is described as follows:
	 * 
	 * Specifies the authentication procedure if the value, "Other" (1) is set for AuthType.
	 * 
	 * @return String current otherAuthType property value
	 * @exception Exception
	 */
	public String getOtherAuthType() {

		return this.otherAuthType;
	} // getOtherAuthType

	/**
	 * This method sets the OSPFProtocolEndpointBase.otherAuthType property value. This property is described as follows:
	 * 
	 * Specifies the authentication procedure if the value, "Other" (1) is set for AuthType.
	 * 
	 * @param String
	 *            new otherAuthType property value
	 * @exception Exception
	 */
	public void setOtherAuthType(String otherAuthType) {

		this.otherAuthType = otherAuthType;
	} // setOtherAuthType

	/**
	 * The following constants are defined for use with the ValueMap/Values qualified property authKey.
	 */
	private String	authKey;

	/**
	 * This method returns the OSPFProtocolEndpointBase.authKey property value. This property is described as follows:
	 * 
	 * This key is used during the authentication procedure to verify OSPF protocol packets, see C.3 RFC 2328. It is used in the "Simple password" and
	 * in the "Cryptographic authentication" case too.
	 * 
	 * @return String current authKey property value
	 * @exception Exception
	 */
	public String getAuthKey() {

		return this.authKey;
	} // getAuthKey

	/**
	 * This method sets the OSPFProtocolEndpointBase.authKey property value. This property is described as follows:
	 * 
	 * This key is used during the authentication procedure to verify OSPF protocol packets, see C.3 RFC 2328. It is used in the "Simple password" and
	 * in the "Cryptographic authentication" case too.
	 * 
	 * @param String
	 *            new authKey property value
	 * @exception Exception
	 */
	public void setAuthKey(String authKey) {

		this.authKey = authKey;
	} // setAuthKey

} // Class OSPFProtocolEndpointBase
