/**
 * This file was auto-generated by mofcomp -j version 1.0.0 on Wed Jan 12
 * 09:21:06 CET 2011.
 */

package org.opennaas.extensions.router.model;

import java.io.Serializable;

/**
 * This Class contains accessor and mutator methods for all properties defined in the CIM class RoutersInAS as well as methods comparable to the
 * invokeMethods defined for this class. This Class implements the RoutersInASBean Interface. The CIM class RoutersInAS is described as follows:
 * 
 * This aggregation establishes 'whole-part' relationships between an AutonomousSystem and the routers that it contains. In addition, the routers in
 * the AS share common configuration information, and are commonly administered.
 */
public class RoutersInAS extends SystemComponent implements Serializable {

	/**
	 * This constructor creates a RoutersInASBeanImpl Class which implements the RoutersInASBean Interface, and encapsulates the CIM class RoutersInAS
	 * in a Java Bean. The CIM class RoutersInAS is described as follows:
	 * 
	 * This aggregation establishes 'whole-part' relationships between an AutonomousSystem and the routers that it contains. In addition, the routers
	 * in the AS share common configuration information, and are commonly administered.
	 */
	public RoutersInAS() {
	};

	/**
	 * This method create an Association of the type RoutersInAS between one AutonomousSystem object and ComputerSystem object
	 */
	public static RoutersInAS link(AutonomousSystem
			groupComponent, ComputerSystem partComponent) {

		return (RoutersInAS) Association.link(RoutersInAS.class, groupComponent, partComponent);
	}// link

	/**
	 * The following constants are defined for use with the ValueMap/Values qualified property bGPSupportedAttributes.
	 */
	private String[]	bGPSupportedAttributes;

	/**
	 * This method returns the RoutersInAS.bGPSupportedAttributes property value. This property is described as follows:
	 * 
	 * This is an array of strings that contain the BGP attributes supported by this router.
	 * 
	 * @return String[] current bGPSupportedAttributes property value
	 * @exception Exception
	 */
	public String[] getBGPSupportedAttributes() {

		return this.bGPSupportedAttributes;
	} // getBGPSupportedAttributes

	/**
	 * This method sets the RoutersInAS.bGPSupportedAttributes property value. This property is described as follows:
	 * 
	 * This is an array of strings that contain the BGP attributes supported by this router.
	 * 
	 * @param String
	 *            [] new bGPSupportedAttributes property value
	 * @exception Exception
	 */
	public void setBGPSupportedAttributes(String[] bGPSupportedAttributes) {

		this.bGPSupportedAttributes = bGPSupportedAttributes;
	} // setBGPSupportedAttributes

	/**
	 * The following constants are defined for use with the ValueMap/Values qualified property addCommunityValue.
	 */
	private boolean	addCommunityValue;

	/**
	 * This method returns the RoutersInAS.addCommunityValue property value. This property is described as follows:
	 * 
	 * TRUE means that the community value of this router is added to the existing community value, and FALSE means that the community value of this
	 * router replaces the existing community value.
	 * 
	 * @return boolean current addCommunityValue property value
	 * @exception Exception
	 */
	public boolean isAddCommunityValue() {

		return this.addCommunityValue;
	} // getAddCommunityValue

	/**
	 * This method sets the RoutersInAS.addCommunityValue property value. This property is described as follows:
	 * 
	 * TRUE means that the community value of this router is added to the existing community value, and FALSE means that the community value of this
	 * router replaces the existing community value.
	 * 
	 * @param boolean new addCommunityValue property value
	 * @exception Exception
	 */
	public void setAddCommunityValue(boolean addCommunityValue) {

		this.addCommunityValue = addCommunityValue;
	} // setAddCommunityValue

	/**
	 * The following constants are defined for use with the ValueMap/Values qualified property Role.
	 */

	public enum Role {
		UNKNOWN,
		OTHER,
		CONVENTIONAL_BGP_SPEAKER,
		ROUTE_REFLECTOR,
		ROUTER_REFLECTOR_CLIENT,
		ROUTE_REFLECTOR_NON_CLIENT,
		PEER_GROUP_MEMBER,
		CONFEDERATION_MEMBER
	}

	private Role	role;

	/**
	 * This method returns the RoutersInAS.role property value. This property is described as follows:
	 * 
	 * This is an enumeration that defines the function, from the point of view of BGP, of this router.
	 * 
	 * @return int current role property value
	 * @exception Exception
	 */
	public Role getRole() {

		return this.role;
	} // getRole

	/**
	 * This method sets the RoutersInAS.role property value. This property is described as follows:
	 * 
	 * This is an enumeration that defines the function, from the point of view of BGP, of this router.
	 * 
	 * @param int new role property value
	 * @exception Exception
	 */
	public void setRole(Role role) {

		this.role = role;
	} // setRole

	/**
	 * The following constants are defined for use with the ValueMap/Values qualified property otherRoleDescription.
	 */
	private String	otherRoleDescription;

	/**
	 * This method returns the RoutersInAS.otherRoleDescription property value. This property is described as follows:
	 * 
	 * A string describing the type of function that this router has in its AS when the value of the Role property of this class is set to 1 (i.e.,
	 * "Other"). The format of the string inserted in this property should be similar in format to the values defined for the Role property. This
	 * property should be set to NULL when the Role property is any value other than 1.
	 * 
	 * @return String current otherRoleDescription property value
	 * @exception Exception
	 */
	public String getOtherRoleDescription() {

		return this.otherRoleDescription;
	} // getOtherRoleDescription

	/**
	 * This method sets the RoutersInAS.otherRoleDescription property value. This property is described as follows:
	 * 
	 * A string describing the type of function that this router has in its AS when the value of the Role property of this class is set to 1 (i.e.,
	 * "Other"). The format of the string inserted in this property should be similar in format to the values defined for the Role property. This
	 * property should be set to NULL when the Role property is any value other than 1.
	 * 
	 * @param String
	 *            new otherRoleDescription property value
	 * @exception Exception
	 */
	public void setOtherRoleDescription(String otherRoleDescription) {

		this.otherRoleDescription = otherRoleDescription;
	} // setOtherRoleDescription

} // Class RoutersInAS
