/**
 * This file was auto-generated by mofcomp -j version 1.0.0 on Wed Jan 12
 * 09:21:06 CET 2011.
 */

package org.opennaas.extensions.router.model;

import java.io.*;
import java.lang.Exception;

/**
 * This Class contains accessor and mutator methods for all properties defined in the CIM class BGPPathAttributes as well as methods comparable to the
 * invokeMethods defined for this class. This Class implements the BGPPathAttributesBean Interface. The CIM class BGPPathAttributes is described as
 * follows:
 * 
 * This class defines the per-path information used to process specific BGP attribute information, as defined in the bgp4PathAttrTable of RFC 1657.
 */
public class BGPPathAttributes extends LogicalElement implements Serializable
{

	/**
	 * This constructor creates a BGPPathAttributesBeanImpl Class which implements the BGPPathAttributesBean Interface, and encapsulates the CIM class
	 * BGPPathAttributes in a Java Bean. The CIM class BGPPathAttributes is described as follows:
	 * 
	 * This class defines the per-path information used to process specific BGP attribute information, as defined in the bgp4PathAttrTable of RFC
	 * 1657.
	 */
	public BGPPathAttributes() {
	};

	/**
	 * The following constants are defined for use with the ValueMap/Values qualified property aSNumbers.
	 */
	private String	aSNumbers;

	/**
	 * This method returns the BGPPathAttributes.aSNumbers property value. This property is described as follows:
	 * 
	 * A comma-separated list of AS numbers, as would be stored in the value portion of the path segment in the PathAttrASPathSegment property. This
	 * list can be ordered or unordered.
	 * 
	 * @return String current aSNumbers property value
	 * @exception Exception
	 */
	public String getASNumbers() {

		return this.aSNumbers;
	} // getASNumbers

	/**
	 * This method sets the BGPPathAttributes.aSNumbers property value. This property is described as follows:
	 * 
	 * A comma-separated list of AS numbers, as would be stored in the value portion of the path segment in the PathAttrASPathSegment property. This
	 * list can be ordered or unordered.
	 * 
	 * @param String
	 *            new aSNumbers property value
	 * @exception Exception
	 */
	public void setASNumbers(String aSNumbers) {

		this.aSNumbers = aSNumbers;
	} // setASNumbers

	/**
	 * The following constants are defined for use with the ValueMap/Values qualified property pathAttrNextHop.
	 */
	private String	pathAttrNextHop;

	/**
	 * This method returns the BGPPathAttributes.pathAttrNextHop property value. This property is described as follows:
	 * 
	 * This is the address of the border router that should be used for the destination network.
	 * 
	 * @return String current pathAttrNextHop property value
	 * @exception Exception
	 */
	public String getPathAttrNextHop() {

		return this.pathAttrNextHop;
	} // getPathAttrNextHop

	/**
	 * This method sets the BGPPathAttributes.pathAttrNextHop property value. This property is described as follows:
	 * 
	 * This is the address of the border router that should be used for the destination network.
	 * 
	 * @param String
	 *            new pathAttrNextHop property value
	 * @exception Exception
	 */
	public void setPathAttrNextHop(String pathAttrNextHop) {

		this.pathAttrNextHop = pathAttrNextHop;
	} // setPathAttrNextHop

	/**
	 * The following constants are defined for use with the ValueMap/Values qualified property pathAttrASPathSegment.
	 */
	private short[]	pathAttrASPathSegment;

	/**
	 * This method returns the BGPPathAttributes.pathAttrASPathSegment property value. This property is described as follows:
	 * 
	 * This property and its description are taken directly from RFC 1657. The property represents a sequence of AS path segments. Each AS path
	 * segment is represented by the tuple: <type, length, value> The type is a 1-octet field which has two possible values: 1 = AS_SET 2 =
	 * AS_SEQUENCE An AS_SET is an unordered set of ASs representing the path that an UPDATE message has traversed, and an AS_SEQUENCE is an ordered
	 * set of ASs representing the path that an UPDATE message has traversed. The length is a 1-octet field containing the number of ASs in the value
	 * field. The value field contains one or more AS numbers, each AS is represented in the octet string as a pair of octets according to the
	 * following algorithm: first-byte-of-pair = ASNumber / 256; second-byte-of-pair = ASNumber & 255; This property is mapped from the
	 * bgp4PathAttrASPathSegment MIB variable, which is an OctetString. Its length is defined as a minimum of 2 and a maximum of 255 octets.
	 * 
	 * @return short[] current pathAttrASPathSegment property value
	 * @exception Exception
	 */
	public short[] getPathAttrASPathSegment() {

		return this.pathAttrASPathSegment;
	} // getPathAttrASPathSegment

	/**
	 * This method sets the BGPPathAttributes.pathAttrASPathSegment property value. This property is described as follows:
	 * 
	 * This property and its description are taken directly from RFC 1657. The property represents a sequence of AS path segments. Each AS path
	 * segment is represented by the tuple: <type, length, value> The type is a 1-octet field which has two possible values: 1 = AS_SET 2 =
	 * AS_SEQUENCE An AS_SET is an unordered set of ASs representing the path that an UPDATE message has traversed, and an AS_SEQUENCE is an ordered
	 * set of ASs representing the path that an UPDATE message has traversed. The length is a 1-octet field containing the number of ASs in the value
	 * field. The value field contains one or more AS numbers, each AS is represented in the octet string as a pair of octets according to the
	 * following algorithm: first-byte-of-pair = ASNumber / 256; second-byte-of-pair = ASNumber & 255; This property is mapped from the
	 * bgp4PathAttrASPathSegment MIB variable, which is an OctetString. Its length is defined as a minimum of 2 and a maximum of 255 octets.
	 * 
	 * @param short[] new pathAttrASPathSegment property value
	 * @exception Exception
	 */
	public void setPathAttrASPathSegment(short[] pathAttrASPathSegment) {

		this.pathAttrASPathSegment = pathAttrASPathSegment;
	} // setPathAttrASPathSegment

	/**
	 * The following constants are defined for use with the ValueMap/Values qualified property PathAttrOrigin.
	 */

	public enum PathAttrOrigin {
		IGP,
		EGP,
		INCOMPLETE
	}

	private PathAttrOrigin	pathAttrOrigin;

	/**
	 * This method returns the BGPPathAttributes.pathAttrOrigin property value. This property is described as follows:
	 * 
	 * This is an enumeration that defines the ultimate origin of the path information. The value 'IGP' means that the origin is interior; the value
	 * 'EGP' means that it was learned via an EGP; the value 'INCOMPLETE' means that the origin is undetermined.
	 * 
	 * @return int current pathAttrOrigin property value
	 * @exception Exception
	 */
	public PathAttrOrigin getPathAttrOrigin() {

		return this.pathAttrOrigin;
	} // getPathAttrOrigin

	/**
	 * This method sets the BGPPathAttributes.pathAttrOrigin property value. This property is described as follows:
	 * 
	 * This is an enumeration that defines the ultimate origin of the path information. The value 'IGP' means that the origin is interior; the value
	 * 'EGP' means that it was learned via an EGP; the value 'INCOMPLETE' means that the origin is undetermined.
	 * 
	 * @param int new pathAttrOrigin property value
	 * @exception Exception
	 */
	public void setPathAttrOrigin(PathAttrOrigin pathAttrOrigin) {

		this.pathAttrOrigin = pathAttrOrigin;
	} // setPathAttrOrigin

	/**
	 * The following constants are defined for use with the ValueMap/Values qualified property pathAttrMultiExitDisc.
	 */
	private int	pathAttrMultiExitDisc;

	/**
	 * This method returns the BGPPathAttributes.pathAttrMultiExitDisc property value. This property is described as follows:
	 * 
	 * This metric is used to discriminate between multiple adjacent autonomous systems. A value of -1 indicates the absence of this attribute. The
	 * range of this attribute is defined to be -1 to 2147483647.
	 * 
	 * @return int current pathAttrMultiExitDisc property value
	 * @exception Exception
	 */
	public int getPathAttrMultiExitDisc() {

		return this.pathAttrMultiExitDisc;
	} // getPathAttrMultiExitDisc

	/**
	 * This method sets the BGPPathAttributes.pathAttrMultiExitDisc property value. This property is described as follows:
	 * 
	 * This metric is used to discriminate between multiple adjacent autonomous systems. A value of -1 indicates the absence of this attribute. The
	 * range of this attribute is defined to be -1 to 2147483647.
	 * 
	 * @param int new pathAttrMultiExitDisc property value
	 * @exception Exception
	 */
	public void setPathAttrMultiExitDisc(int pathAttrMultiExitDisc) {

		this.pathAttrMultiExitDisc = pathAttrMultiExitDisc;
	} // setPathAttrMultiExitDisc

	/**
	 * The following constants are defined for use with the ValueMap/Values qualified property pathAttrLocalPref.
	 */
	private int	pathAttrLocalPref;

	/**
	 * This method returns the BGPPathAttributes.pathAttrLocalPref property value. This property is described as follows:
	 * 
	 * This is the originating BGP4 speaker's degree of preference for an advertised route. A value of -1 indicates the absence of this attribute. The
	 * range of this attribute is defined to be -1 to 2147483647.
	 * 
	 * @return int current pathAttrLocalPref property value
	 * @exception Exception
	 */
	public int getPathAttrLocalPref() {

		return this.pathAttrLocalPref;
	} // getPathAttrLocalPref

	/**
	 * This method sets the BGPPathAttributes.pathAttrLocalPref property value. This property is described as follows:
	 * 
	 * This is the originating BGP4 speaker's degree of preference for an advertised route. A value of -1 indicates the absence of this attribute. The
	 * range of this attribute is defined to be -1 to 2147483647.
	 * 
	 * @param int new pathAttrLocalPref property value
	 * @exception Exception
	 */
	public void setPathAttrLocalPref(int pathAttrLocalPref) {

		this.pathAttrLocalPref = pathAttrLocalPref;
	} // setPathAttrLocalPref

	/**
	 * The following constants are defined for use with the ValueMap/Values qualified property PathAttrAtomicAggregate.
	 */

	public enum PathAttrAtomicAggregate {
		UNKNOWN,
		LESS_SPECIFIC_NOT_SELECTED,
		LESS_SPECIFIC_SELECTED
	}

	private PathAttrAtomicAggregate	pathAttrAtomicAggregate;

	/**
	 * This method returns the BGPPathAttributes.pathAttrAtomicAggregate property value. This property is described as follows:
	 * 
	 * This is an enumeration that defines whether or not the local system has selected a less specific route without selecting a more specific route.
	 * There are two values, 1 and 2, indicating that a less specific route has not and has been selected, respectively. This is a 32-bit integer to
	 * correspond to the IETF MIB.
	 * 
	 * @return long current pathAttrAtomicAggregate property value
	 * @exception Exception
	 */
	public PathAttrAtomicAggregate getPathAttrAtomicAggregate() {

		return this.pathAttrAtomicAggregate;
	} // getPathAttrAtomicAggregate

	/**
	 * This method sets the BGPPathAttributes.pathAttrAtomicAggregate property value. This property is described as follows:
	 * 
	 * This is an enumeration that defines whether or not the local system has selected a less specific route without selecting a more specific route.
	 * There are two values, 1 and 2, indicating that a less specific route has not and has been selected, respectively. This is a 32-bit integer to
	 * correspond to the IETF MIB.
	 * 
	 * @param long new pathAttrAtomicAggregate property value
	 * @exception Exception
	 */
	public void setPathAttrAtomicAggregate(PathAttrAtomicAggregate
			pathAttrAtomicAggregate) {

		this.pathAttrAtomicAggregate = pathAttrAtomicAggregate;
	} // setPathAttrAtomicAggregate

	/**
	 * The following constants are defined for use with the ValueMap/Values qualified property pathAttrAggregatorAS.
	 */
	private int	pathAttrAggregatorAS;

	/**
	 * This method returns the BGPPathAttributes.pathAttrAggregatorAS property value. This property is described as follows:
	 * 
	 * This is the AS number of the last BGP speaker that performed route aggregation. A value of 0 indicates the absence of this attribute. The range
	 * of this attribute is defined to be 0 to 65535.
	 * 
	 * @return int current pathAttrAggregatorAS property value
	 * @exception Exception
	 */
	public int getPathAttrAggregatorAS() {

		return this.pathAttrAggregatorAS;
	} // getPathAttrAggregatorAS

	/**
	 * This method sets the BGPPathAttributes.pathAttrAggregatorAS property value. This property is described as follows:
	 * 
	 * This is the AS number of the last BGP speaker that performed route aggregation. A value of 0 indicates the absence of this attribute. The range
	 * of this attribute is defined to be 0 to 65535.
	 * 
	 * @param int new pathAttrAggregatorAS property value
	 * @exception Exception
	 */
	public void setPathAttrAggregatorAS(int pathAttrAggregatorAS) {

		this.pathAttrAggregatorAS = pathAttrAggregatorAS;
	} // setPathAttrAggregatorAS

	/**
	 * The following constants are defined for use with the ValueMap/Values qualified property pathAttrAggregatorAddr.
	 */
	private String	pathAttrAggregatorAddr;

	/**
	 * This method returns the BGPPathAttributes.pathAttrAggregatorAddr property value. This property is described as follows:
	 * 
	 * This is the IP address of the last BGP speaker that performed route aggregation. A value of 0.0.0.0 indicates the absence of this attribute.
	 * 
	 * @return String current pathAttrAggregatorAddr property value
	 * @exception Exception
	 */
	public String getPathAttrAggregatorAddr() {

		return this.pathAttrAggregatorAddr;
	} // getPathAttrAggregatorAddr

	/**
	 * This method sets the BGPPathAttributes.pathAttrAggregatorAddr property value. This property is described as follows:
	 * 
	 * This is the IP address of the last BGP speaker that performed route aggregation. A value of 0.0.0.0 indicates the absence of this attribute.
	 * 
	 * @param String
	 *            new pathAttrAggregatorAddr property value
	 * @exception Exception
	 */
	public void setPathAttrAggregatorAddr(String pathAttrAggregatorAddr) {

		this.pathAttrAggregatorAddr = pathAttrAggregatorAddr;
	} // setPathAttrAggregatorAddr

	/**
	 * The following constants are defined for use with the ValueMap/Values qualified property pathAttrCalcLocalPref.
	 */
	private Short	pathAttrCalcLocalPref;

	/**
	 * This method returns the BGPPathAttributes.pathAttrCalcLocalPref property value. This property is described as follows:
	 * 
	 * This is the degree of preference calculated by the receiving BGP speaker for an advertised route. A value of -1 indicates the absence of this
	 * attribute. The range of this attribute is defined to be -1 to 2147483647.
	 * 
	 * @return Short current pathAttrCalcLocalPref property value
	 * @exception Exception
	 */
	public Short getPathAttrCalcLocalPref() {

		return this.pathAttrCalcLocalPref;
	} // getPathAttrCalcLocalPref

	/**
	 * This method sets the BGPPathAttributes.pathAttrCalcLocalPref property value. This property is described as follows:
	 * 
	 * This is the degree of preference calculated by the receiving BGP speaker for an advertised route. A value of -1 indicates the absence of this
	 * attribute. The range of this attribute is defined to be -1 to 2147483647.
	 * 
	 * @param Short
	 *            new pathAttrCalcLocalPref property value
	 * @exception Exception
	 */
	public void setPathAttrCalcLocalPref(Short pathAttrCalcLocalPref) {

		this.pathAttrCalcLocalPref = pathAttrCalcLocalPref;
	} // setPathAttrCalcLocalPref

	/**
	 * The following constants are defined for use with the ValueMap/Values qualified property PathAttrBest.
	 */

	public enum PathAttrBest {
		UNKNOWN,
		FALSE,
		TRUE
	}

	private PathAttrBest	pathAttrBest;

	/**
	 * This method returns the BGPPathAttributes.pathAttrBest property value. This property is described as follows:
	 * 
	 * This is an indication of whether or not this route was chosen as the best BGP route. There are three possible values, 0 (Unknown), 1 (FALSE)
	 * and 2 (TRUE).
	 * 
	 * @return int current pathAttrBest property value
	 * @exception Exception
	 */
	public PathAttrBest getPathAttrBest() {

		return this.pathAttrBest;
	} // getPathAttrBest

	/**
	 * This method sets the BGPPathAttributes.pathAttrBest property value. This property is described as follows:
	 * 
	 * This is an indication of whether or not this route was chosen as the best BGP route. There are three possible values, 0 (Unknown), 1 (FALSE)
	 * and 2 (TRUE).
	 * 
	 * @param int new pathAttrBest property value
	 * @exception Exception
	 */
	public void setPathAttrBest(PathAttrBest pathAttrBest) {

		this.pathAttrBest = pathAttrBest;
	} // setPathAttrBest

	/**
	 * The following constants are defined for use with the ValueMap/Values qualified property pathAttrUnknown.
	 */
	private String[]	pathAttrUnknown;

	/**
	 * This method returns the BGPPathAttributes.pathAttrUnknown property value. This property is described as follows:
	 * 
	 * This contains one or more path atributes not understood by this BGP speaker. It is a array of path attributes that are not understood. The
	 * number of attributes is placed in a separate property of this class, PathAttrUnknownNumber.
	 * 
	 * @return String[] current pathAttrUnknown property value
	 * @exception Exception
	 */
	public String[] getPathAttrUnknown() {

		return this.pathAttrUnknown;
	} // getPathAttrUnknown

	/**
	 * This method sets the BGPPathAttributes.pathAttrUnknown property value. This property is described as follows:
	 * 
	 * This contains one or more path atributes not understood by this BGP speaker. It is a array of path attributes that are not understood. The
	 * number of attributes is placed in a separate property of this class, PathAttrUnknownNumber.
	 * 
	 * @param String
	 *            [] new pathAttrUnknown property value
	 * @exception Exception
	 */
	public void setPathAttrUnknown(String[] pathAttrUnknown) {

		this.pathAttrUnknown = pathAttrUnknown;
	} // setPathAttrUnknown

	/**
	 * The following constants are defined for use with the ValueMap/Values qualified property pathAttrUnknownNumber.
	 */
	private int	pathAttrUnknownNumber;

	/**
	 * This method returns the BGPPathAttributes.pathAttrUnknownNumber property value. This property is described as follows:
	 * 
	 * The number of unknown attributes in the array, PathAttrUnknown.
	 * 
	 * @return int current pathAttrUnknownNumber property value
	 * @exception Exception
	 */
	public int getPathAttrUnknownNumber() {

		return this.pathAttrUnknownNumber;
	} // getPathAttrUnknownNumber

	/**
	 * This method sets the BGPPathAttributes.pathAttrUnknownNumber property value. This property is described as follows:
	 * 
	 * The number of unknown attributes in the array, PathAttrUnknown.
	 * 
	 * @param int new pathAttrUnknownNumber property value
	 * @exception Exception
	 */
	public void setPathAttrUnknownNumber(int pathAttrUnknownNumber) {

		this.pathAttrUnknownNumber = pathAttrUnknownNumber;
	} // setPathAttrUnknownNumber

} // Class BGPPathAttributes
