/**
 * This file was auto-generated by mofcomp -j version 1.0.0 on Wed Jan 12
 * 09:21:06 CET 2011.
 */

package org.opennaas.extensions.router.model;

import java.io.Serializable;

/**
 * This Class contains accessor and mutator methods for all properties defined in the CIM class BGPRouteMap as well as methods comparable to the
 * invokeMethods defined for this class. This Class implements the BGPRouteMapBean Interface. The CIM class BGPRouteMap is described as follows:
 * 
 * A route map is used to control and modify routing information as well as to define when a route is redistributed between routing domains. Route
 * maps are placed in router configuration files, and several instances of the same route map may be used to implement different actions. RouteMaps
 * MAY use FilterLists to identify the route. A BGPRouteMap is specific to a given AutonomousSystem that contains it. Hence, the keys of the
 * AutonomousSystem are propagated to this class.
 */
public class BGPRouteMap extends LogicalElement implements Serializable {

	/**
	 * This constructor creates a BGPRouteMapBeanImpl Class which implements the BGPRouteMapBean Interface, and encapsulates the CIM class BGPRouteMap
	 * in a Java Bean. The CIM class BGPRouteMap is described as follows:
	 * 
	 * A route map is used to control and modify routing information as well as to define when a route is redistributed between routing domains. Route
	 * maps are placed in router configuration files, and several instances of the same route map may be used to implement different actions.
	 * RouteMaps MAY use FilterLists to identify the route. A BGPRouteMap is specific to a given AutonomousSystem that contains it. Hence, the keys of
	 * the AutonomousSystem are propagated to this class.
	 */
	public BGPRouteMap() {
	};

	/**
	 * The following constants are defined for use with the ValueMap/Values qualified property systemCreationClassName.
	 */
	private String	systemCreationClassName;

	/**
	 * This method returns the BGPRouteMap.systemCreationClassName property value. This property is described as follows:
	 * 
	 * The scoping AutonomousSystem's CreationClassName.
	 * 
	 * @return String current systemCreationClassName property value
	 * @exception Exception
	 */
	public String getSystemCreationClassName() {

		return this.systemCreationClassName;
	} // getSystemCreationClassName

	/**
	 * This method sets the BGPRouteMap.systemCreationClassName property value. This property is described as follows:
	 * 
	 * The scoping AutonomousSystem's CreationClassName.
	 * 
	 * @param String
	 *            new systemCreationClassName property value
	 * @exception Exception
	 */
	public void setSystemCreationClassName(String systemCreationClassName) {

		this.systemCreationClassName = systemCreationClassName;
	} // setSystemCreationClassName

	/**
	 * The following constants are defined for use with the ValueMap/Values qualified property systemName.
	 */
	private String	systemName;

	/**
	 * This method returns the BGPRouteMap.systemName property value. This property is described as follows:
	 * 
	 * The scoping AutonomousSystem's Name.
	 * 
	 * @return String current systemName property value
	 * @exception Exception
	 */
	public String getSystemName() {

		return this.systemName;
	} // getSystemName

	/**
	 * This method sets the BGPRouteMap.systemName property value. This property is described as follows:
	 * 
	 * The scoping AutonomousSystem's Name.
	 * 
	 * @param String
	 *            new systemName property value
	 * @exception Exception
	 */
	public void setSystemName(String systemName) {

		this.systemName = systemName;
	} // setSystemName

	/**
	 * The following constants are defined for use with the ValueMap/Values qualified property creationClassName.
	 */
	private String	creationClassName;

	/**
	 * This method returns the BGPRouteMap.creationClassName property value. This property is described as follows:
	 * 
	 * CreationClassName indicates the name of the class or the subclass used in the creation of an instance. When used with the other key properties
	 * of this class, this property allows all instances of this class and its subclasses to be uniquely identified.
	 * 
	 * @return String current creationClassName property value
	 * @exception Exception
	 */
	public String getCreationClassName() {

		return this.creationClassName;
	} // getCreationClassName

	/**
	 * This method sets the BGPRouteMap.creationClassName property value. This property is described as follows:
	 * 
	 * CreationClassName indicates the name of the class or the subclass used in the creation of an instance. When used with the other key properties
	 * of this class, this property allows all instances of this class and its subclasses to be uniquely identified.
	 * 
	 * @param String
	 *            new creationClassName property value
	 * @exception Exception
	 */
	public void setCreationClassName(String creationClassName) {

		this.creationClassName = creationClassName;
	} // setCreationClassName

	// /**
	// * The following constants are defined for use with the ValueMap/Values
	// * qualified property name.
	// */
	// private String name;
	/**
	 * This method returns the BGPRouteMap.name property value. This property is described as follows:
	 * 
	 * This is the name of the RouteMap class.
	 * 
	 * @return String current name property value
	 * @exception Exception
	 */
	@Override
	public String getName() {
		return super.getName();
	} // getName

	/**
	 * This method sets the BGPRouteMap.name property value. This property is described as follows:
	 * 
	 * This is the name of the RouteMap class.
	 * 
	 * @param String
	 *            new name property value
	 * @exception Exception
	 */
	@Override
	public void setName(String name) {
		super.setName(name);
	} // setName

	/**
	 * The following constants are defined for use with the ValueMap/Values qualified property Direction.
	 */

	public enum Direction {
		INPUT,
		OUTPUT,
		BOTH
	}

	private Direction	direction;

	/**
	 * This method returns the BGPRouteMap.direction property value. This property is described as follows:
	 * 
	 * This defines whether this RouteMap is used for input, output, or both input and output filtering.
	 * 
	 * @return int current direction property value
	 * @exception Exception
	 */
	public Direction getDirection() {

		return this.direction;
	} // getDirection

	/**
	 * This method sets the BGPRouteMap.direction property value. This property is described as follows:
	 * 
	 * This defines whether this RouteMap is used for input, output, or both input and output filtering.
	 * 
	 * @param int new direction property value
	 * @exception Exception
	 */
	public void setDirection(Direction direction) {

		this.direction = direction;
	} // setDirection

	/**
	 * The following constants are defined for use with the ValueMap/Values qualified property Action.
	 */

	public enum Action {
		PERMIT,
		DENY
	}

	private Action	action;

	/**
	 * This method returns the BGPRouteMap.action property value. This property is described as follows:
	 * 
	 * This defines whether the action should be to forward or deny traffic meeting the match condition specified in this RouteMap.
	 * 
	 * @return int current action property value
	 * @exception Exception
	 */
	public Action getAction() {

		return this.action;
	} // getAction

	/**
	 * This method sets the BGPRouteMap.action property value. This property is described as follows:
	 * 
	 * This defines whether the action should be to forward or deny traffic meeting the match condition specified in this RouteMap.
	 * 
	 * @param int new action property value
	 * @exception Exception
	 */
	public void setAction(Action action) {

		this.action = action;
	} // setAction

	/**
	 * The following constants are defined for use with the ValueMap/Values qualified property MatchConditionType.
	 */

	public enum MatchConditionType {
		OTHER,
		SOURCE_ADDRESS_AND_MASK,
		DESTINATION_ADDRESS_AND_MASK,
		SOURCE_PORT,
		SOURCE_PORT_RANGE,
		DESTINATION_PORT,
		DESTINATION_PORT_RANGE,
		PROTOCOL_TYPE,
		PROTOCOL_TYPE_AND_OPTION
	}

	private MatchConditionType	matchConditionType;

	/**
	 * This method returns the BGPRouteMap.matchConditionType property value. This property is described as follows:
	 * 
	 * This specifies the criteria that must be matched in order for the corresponding MatchAction to take effect. The matching of the criteria may be
	 * specified by using a FilterList. For example, the command 'match ip address foo' uses the FilterList named 'foo' to do the matching of IP
	 * addresses.
	 * 
	 * @return int current matchConditionType property value
	 * @exception Exception
	 */
	public MatchConditionType getMatchConditionType() {

		return this.matchConditionType;
	} // getMatchConditionType

	/**
	 * This method sets the BGPRouteMap.matchConditionType property value. This property is described as follows:
	 * 
	 * This specifies the criteria that must be matched in order for the corresponding MatchAction to take effect. The matching of the criteria may be
	 * specified by using a FilterList. For example, the command 'match ip address foo' uses the FilterList named 'foo' to do the matching of IP
	 * addresses.
	 * 
	 * @param int new matchConditionType property value
	 * @exception Exception
	 */
	public void setMatchConditionType(MatchConditionType
			matchConditionType) {

		this.matchConditionType = matchConditionType;
	} // setMatchConditionType

	/**
	 * The following constants are defined for use with the ValueMap/Values qualified property otherMatchConditionType.
	 */
	private String	otherMatchConditionType;

	/**
	 * This method returns the BGPRouteMap.otherMatchConditionType property value. This property is described as follows:
	 * 
	 * If the value of the MatchConditionType property in this class is 1 (i.e., "Other"), then the specific type of filtering is specified in this
	 * property.
	 * 
	 * @return String current otherMatchConditionType property value
	 * @exception Exception
	 */
	public String getOtherMatchConditionType() {

		return this.otherMatchConditionType;
	} // getOtherMatchConditionType

	/**
	 * This method sets the BGPRouteMap.otherMatchConditionType property value. This property is described as follows:
	 * 
	 * If the value of the MatchConditionType property in this class is 1 (i.e., "Other"), then the specific type of filtering is specified in this
	 * property.
	 * 
	 * @param String
	 *            new otherMatchConditionType property value
	 * @exception Exception
	 */
	public void setOtherMatchConditionType(String otherMatchConditionType) {

		this.otherMatchConditionType = otherMatchConditionType;
	} // setOtherMatchConditionType

	/**
	 * The following constants are defined for use with the ValueMap/Values qualified property SetMetricType.
	 */

	public enum SetMetricType {
		ORIGIN,
		AS_PATH,
		NEXT_HOP,
		MULTI_EXIT_DISC,
		LOCAL_PREF,
		ATOMIC_AGGREGATE,
		AGGREGATOR,
		COMMUNITY,
		ORIGINATOR_ID
	}

	private SetMetricType	setMetricType;

	/**
	 * This method returns the BGPRouteMap.setMetricType property value. This property is described as follows:
	 * 
	 * This defines an additional action to take if the MatchCondition is satisfied. This definition is specifically limited to BGP filtering at this
	 * time. The actual value of the metric is specified in the SetMetricValue property.
	 * 
	 * @return int current setMetricType property value
	 * @exception Exception
	 */
	public SetMetricType getSetMetricType() {

		return this.setMetricType;
	} // getSetMetricType

	/**
	 * This method sets the BGPRouteMap.setMetricType property value. This property is described as follows:
	 * 
	 * This defines an additional action to take if the MatchCondition is satisfied. This definition is specifically limited to BGP filtering at this
	 * time. The actual value of the metric is specified in the SetMetricValue property.
	 * 
	 * @param int new setMetricType property value
	 * @exception Exception
	 */
	public void setSetMetricType(SetMetricType setMetricType) {

		this.setMetricType = setMetricType;
	} // setSetMetricType

	/**
	 * The following constants are defined for use with the ValueMap/Values qualified property setMetricValue.
	 */
	private String	setMetricValue;

	/**
	 * This method returns the BGPRouteMap.setMetricValue property value. This property is described as follows:
	 * 
	 * This is the value of the metric that is being set for the BGP attribute defined in the SetMetricType property.
	 * 
	 * @return String current setMetricValue property value
	 * @exception Exception
	 */
	public String getSetMetricValue() {

		return this.setMetricValue;
	} // getSetMetricValue

	/**
	 * This method sets the BGPRouteMap.setMetricValue property value. This property is described as follows:
	 * 
	 * This is the value of the metric that is being set for the BGP attribute defined in the SetMetricType property.
	 * 
	 * @param String
	 *            new setMetricValue property value
	 * @exception Exception
	 */
	public void setSetMetricValue(String setMetricValue) {

		this.setMetricValue = setMetricValue;
	} // setSetMetricValue

} // Class BGPRouteMap
