/**
 * This file was auto-generated by mofcomp -j version 1.0.0 on Wed Jan 12
 * 09:21:06 CET 2011.
 */

package org.opennaas.extensions.router.model;

import java.io.*;
import java.lang.Exception;

/**
 * This Class contains accessor and mutator methods for all properties defined in the CIM class DHCPCapabilities as well as methods comparable to the
 * invokeMethods defined for this class. This Class implements the DHCPCapabilitiesBean Interface. The CIM class DHCPCapabilities is described as
 * follows:
 * 
 * A class derived from EnabledLogicalElementCapabilities representing the capabilities of a DHCP client.
 */
public class DHCPCapabilities extends EnabledLogicalElementCapabilities
		implements Serializable {

	/**
	 * This constructor creates a DHCPCapabilitiesBeanImpl Class which implements the DHCPCapabilitiesBean Interface, and encapsulates the CIM class
	 * DHCPCapabilities in a Java Bean. The CIM class DHCPCapabilities is described as follows:
	 * 
	 * A class derived from EnabledLogicalElementCapabilities representing the capabilities of a DHCP client.
	 */
	public DHCPCapabilities() {
	};

	/**
	 * The following constants are defined for use with the ValueMap/Values qualified property OptionsSupported.
	 */

	public enum OptionsSupported {
		UNKNOWN,
		OTHER,
		PAD,
		SUBNET_MASK,
		TIME_OFFSET,
		ROUTER_OPTION,
		TIME_SERVER,
		NAME_SERVER,
		DOMAIN_NAME_SERVER,
		LOG_SERVER,
		COOKIE_SERVER,
		LPR_SERVER,
		IMPRESS_SERVER,
		RESOURCE_LOCATION_SERVER,
		HOST_NAME,
		BOOT_FILE_SIZE,
		MERIT_DUMP_FILE,
		DOMAIN_NAME,
		SWAP_SERVER,
		ROOT_PATH,
		EXTENSIONS_PATH,
		IP_FORWARDING_ENABLE_DISABLE,
		NON_LOCAL_SOURCE_ROUTING_ENABLE_DISABLE,
		POLICY_FILTER,
		MAXIMUM_DATAGRAM_REASSEMBLY_SIZE,
		DEFAULT_IP_TIME_TO_LIVE,
		PATH_MTU_AGING_TIMEOUT,
		PATH_MTU_PLATEAU_TABLE,
		INTERFACE_MTU,
		ALL_SUBNETS_ARE_LOCAL,
		BROADCAST_ADDRESS,
		PERFORM_SUBNET_MASK_DISCOVERY,
		MASK_SUPPLIER,
		PERFORM_ROUTER_DISCOVERY,
		ROUTER_SOLICITATION_ADDRESS,
		STATIC_ROUTE,
		TRAILER_ENCAPSULATION,
		ARP_CACHE_TIMEOUT,
		ETHERNET_ENCAPSULATION,
		TCP_DEFAULT_TTL,
		TCP_KEEPALIVE_INTERVAL,
		TCP_KEEPALIVE_GARBAGE,
		NETWORK_INFORMATION_SERVICE_DOMAIN,
		NETWORK_INFORMATION_SERVERS,
		NETWORK_TIME_PROTOCOL_SERVERS,
		VENDOR_SPECIFIC_INFORMATION,
		NETBIOS_OVER_TCP_IP_NAME_SERVER,
		NETBIOS_OVER_TCP_IP_DATAGRAM_DISTRIBUTION_SERVER,
		NETBIOS_OVER_TCP_IP_NODE_TYPE,
		NETBIOS_OVER_TCP_IP_SCOPE,
		X_WINDOW_SYSTEM_FONT_SERVER,
		X_WINDOW_SYSTEM_DISPLAY_MANAGER,
		REQUESTED_IP_ADDRESS,
		LEASE_TIME,
		OPTION_OVERLOAD,
		MESSAGE_TYPE,
		SERVER_IDENTIFIER,
		PARAMETER_REQUEST_LIST,
		ERROR_MESSAGE,
		MAXIMUM_MESSAGE_SIZE,
		RENEWAL_T1_TIME,
		REBINDING_T2_TIME,
		VENDOR_CLASS_IDENTIFIER,
		CLIENT_IDENTIFIER,
		DMTF_RESERVED,
		DMTF_RESERVED1,
		NETWORK_INFORMATION_SERVICEPLUS_DOMAINPLUS,
		NETWORK_INFORMATION_SERVICEPLUS_SERVERSPLUS,
		TFTP_SERVER_NAME,
		BOOTFILE_NAME,
		MOBILE_IP_HOME_AGENT,
		SIMPLE_MAIL_TRANSPORT_PROTOCOL_SMTP_SERVER,
		POST_OFFICE_PROTOCOL_POP3_SERVER,
		NETWORK_NEWS_TRANSPORT_PROTOCOL_NNTP_SERVER,
		DEFAULT_WORLD_WIDE_WEB_WWW_SERVER,
		DEFAULT_FINGER_SERVER,
		DEFAULT_INTERNET_RELAY_CHAT_IRC_SERVER,
		STREETTALK_SERVER,
		STREETTALK_DIRECTORY_ASSISTANCE_STDA_SERVER,
		USER_CLASS,
		SLP_DIRECTORY_AGENT,
		SLP_SERVICE_SCOPE,
		DMTF_RESERVED2,
		RELAY_AGENT_INFORMATION,
		DMTF_RESERVED3,
		NAME_SERVICE_SEARCH,
		SUBNET_SELECTION,
		DMTF_RESERVED4,
		CLASSLESS_ROUTE,
		DMTF_RESERVED5,
		END,
		DMTF_RESERVED6,
		VENDOR_RESERVED
	}

	private OptionsSupported	optionsSupported;

	/**
	 * This method returns the DHCPCapabilities.optionsSupported property value. This property is described as follows:
	 * 
	 * One or more DHCP options supported by the DHCP client. These may include: Subnet Mask, Default Router, DNS Server, etc. See RFC2132 for a
	 * description of each option.
	 * 
	 * @return int current optionsSupported property value
	 * @exception Exception
	 */
	public OptionsSupported getOptionsSupported() {

		return this.optionsSupported;
	} // getOptionsSupported

	/**
	 * This method sets the DHCPCapabilities.optionsSupported property value. This property is described as follows:
	 * 
	 * One or more DHCP options supported by the DHCP client. These may include: Subnet Mask, Default Router, DNS Server, etc. See RFC2132 for a
	 * description of each option.
	 * 
	 * @param int new optionsSupported property value
	 * @exception Exception
	 */
	public void setOptionsSupported(OptionsSupported optionsSupported) {

		this.optionsSupported = optionsSupported;
	} // setOptionsSupported

	/**
	 * The following constants are defined for use with the ValueMap/Values qualified property iPv6OptionsSupported.
	 */
	private int[]	iPv6OptionsSupported;

	/**
	 * This method returns the DHCPCapabilities.iPv6OptionsSupported property value. This property is described as follows:
	 * 
	 * One or more DHCP option opcodes supported by the DHCP client for IPv6. The values of this property shall be the option-codes specified in
	 * RFC3315, Section 22.
	 * 
	 * @return int[] current iPv6OptionsSupported property value
	 * @exception Exception
	 */
	public int[] getIPv6OptionsSupported() {

		return this.iPv6OptionsSupported;
	} // getIPv6OptionsSupported

	/**
	 * This method sets the DHCPCapabilities.iPv6OptionsSupported property value. This property is described as follows:
	 * 
	 * One or more DHCP option opcodes supported by the DHCP client for IPv6. The values of this property shall be the option-codes specified in
	 * RFC3315, Section 22.
	 * 
	 * @param int[] new iPv6OptionsSupported property value
	 * @exception Exception
	 */
	public void setIPv6OptionsSupported(int[] iPv6OptionsSupported) {

		this.iPv6OptionsSupported = iPv6OptionsSupported;
	} // setIPv6OptionsSupported

} // Class DHCPCapabilities
