/**
 * This file was auto-generated by mofcomp -j version 1.0.0 on Wed Jan 12
 * 09:21:06 CET 2011.
 */

package org.opennaas.extensions.router.model;

import java.io.*;
import java.lang.Exception;

/**
 * This Class contains accessor and mutator methods for all properties defined in the CIM class DSCPMarkerService as well as methods comparable to the
 * invokeMethods defined for this class. This Class implements the DSCPMarkerServiceBean Interface. The CIM class DSCPMarkerService is described as
 * follows:
 * 
 * DSCPMarkerService marks the differentiated services codepoint (DSCP) within the DS field in the IPv4 and IPv6 packet headers, as defined in
 * [R2474]. It is marked with the specific value defined in the property, DSCPValue. Following common practice, the value to be written into the field
 * is represented as an unsigned 8-bit integer.
 */
public class DSCPMarkerService extends MarkerService implements Serializable
{

	/**
	 * This constructor creates a DSCPMarkerServiceBeanImpl Class which implements the DSCPMarkerServiceBean Interface, and encapsulates the CIM class
	 * DSCPMarkerService in a Java Bean. The CIM class DSCPMarkerService is described as follows:
	 * 
	 * DSCPMarkerService marks the differentiated services codepoint (DSCP) within the DS field in the IPv4 and IPv6 packet headers, as defined in
	 * [R2474]. It is marked with the specific value defined in the property, DSCPValue. Following common practice, the value to be written into the
	 * field is represented as an unsigned 8-bit integer.
	 */
	public DSCPMarkerService() {
	};

	/**
	 * The following constants are defined for use with the ValueMap/Values qualified property dSCPValue.
	 */
	private short	dSCPValue;

	/**
	 * This method returns the DSCPMarkerService.dSCPValue property value. This property is described as follows:
	 * 
	 * This property is an unsigned 8-bit integer, representing a value to be used for marking the DSCP field in an IPv4 or Ipv6 packet header. Since
	 * the DSCP consists of 6 bits, the values for this property are limited to the range 0..63. When the DSCP is marked, the remaining two bits in
	 * the DS field are left unchanged.
	 * 
	 * @return short current dSCPValue property value
	 * @exception Exception
	 */
	public short getDSCPValue() {

		return this.dSCPValue;
	} // getDSCPValue

	/**
	 * This method sets the DSCPMarkerService.dSCPValue property value. This property is described as follows:
	 * 
	 * This property is an unsigned 8-bit integer, representing a value to be used for marking the DSCP field in an IPv4 or Ipv6 packet header. Since
	 * the DSCP consists of 6 bits, the values for this property are limited to the range 0..63. When the DSCP is marked, the remaining two bits in
	 * the DS field are left unchanged.
	 * 
	 * @param short new dSCPValue property value
	 * @exception Exception
	 */
	public void setDSCPValue(short dSCPValue) {

		this.dSCPValue = dSCPValue;
	} // setDSCPValue

} // Class DSCPMarkerService
