/**
 * This file was auto-generated by mofcomp -j version 1.0.0 on Wed Jan 12
 * 09:21:06 CET 2011.
 */

package org.opennaas.extensions.router.model;

import java.io.*;
import java.lang.Exception;

/**
 * This Class contains accessor and mutator methods for all properties defined in the CIM class RouteCalculationService as well as methods comparable
 * to the invokeMethods defined for this class. This Class implements the RouteCalculationServiceBean Interface. The CIM class RouteCalculationService
 * is described as follows:
 * 
 * This is an abstract base class, derived from Service, that represents the route calculation aspects of a system. This class also addresses
 * functions performed by the system when it exchanges routing information. Examining the RouteCalculationService class definition, note that its
 * superclass NetworkService is deprecated. Therefore, NetworkService's properties need not be implemented in an instance of RouteCalculationService.
 * Unfortunately, NetworkService cannot be removed from the object hierarchy without a major Schema release. When/if this occurs, the NetworkService
 * superclass will be removed, and RouteCalculationService will subclass from CIM_Service directly. Also note that there are a large number of
 * additional routing protocols that are not currently modeled. These will be added over time.
 */
public class RouteCalculationService extends NetworkService implements
		Serializable {

	/**
	 * This constructor creates a RouteCalculationServiceBeanImpl Class which implements the RouteCalculationServiceBean Interface, and encapsulates
	 * the CIM class RouteCalculationService in a Java Bean. The CIM class RouteCalculationService is described as follows:
	 * 
	 * This is an abstract base class, derived from Service, that represents the route calculation aspects of a system. This class also addresses
	 * functions performed by the system when it exchanges routing information. Examining the RouteCalculationService class definition, note that its
	 * superclass NetworkService is deprecated. Therefore, NetworkService's properties need not be implemented in an instance of
	 * RouteCalculationService. Unfortunately, NetworkService cannot be removed from the object hierarchy without a major Schema release. When/if this
	 * occurs, the NetworkService superclass will be removed, and RouteCalculationService will subclass from CIM_Service directly. Also note that
	 * there are a large number of additional routing protocols that are not currently modeled. These will be added over time.
	 */
	protected RouteCalculationService() {
	};

	/**
	 * The following constants are defined for use with the ValueMap/Values qualified property routerID.
	 */
	private String	routerID;

	/**
	 * This method returns the RouteCalculationService.routerID property value. This property is described as follows:
	 * 
	 * The RouterID uniquely identifies the router that is performing the route calculation. It is the highest IP address on the router (or the
	 * highest loopback interface, if there is one).
	 * 
	 * @return String current routerID property value
	 * @exception Exception
	 */
	public String getRouterID() {

		return this.routerID;
	} // getRouterID

	/**
	 * This method sets the RouteCalculationService.routerID property value. This property is described as follows:
	 * 
	 * The RouterID uniquely identifies the router that is performing the route calculation. It is the highest IP address on the router (or the
	 * highest loopback interface, if there is one).
	 * 
	 * @param String
	 *            new routerID property value
	 * @exception Exception
	 */
	public void setRouterID(String routerID) {

		this.routerID = routerID;
	} // setRouterID

	/**
	 * The following constants are defined for use with the ValueMap/Values qualified property AlgorithmType.
	 */

	public enum AlgorithmType {
		UNKNOWN,
		RIPV1,
		RIPV2,
		OSPFV1,
		OSPFV2,
		BGPV1,
		BGPV2,
		BGPV3,
		BGPV4
	}

	private AlgorithmType	algorithmType;

	/**
	 * This method returns the RouteCalculationService.algorithmType property value. This property is described as follows:
	 * 
	 * This is an enumerated value that defines the routing algorithm used in this route calculation.
	 * 
	 * @return int current algorithmType property value
	 * @exception Exception
	 */
	public AlgorithmType getAlgorithmType() {

		return this.algorithmType;
	} // getAlgorithmType

	/**
	 * This method sets the RouteCalculationService.algorithmType property value. This property is described as follows:
	 * 
	 * This is an enumerated value that defines the routing algorithm used in this route calculation.
	 * 
	 * @param int new algorithmType property value
	 * @exception Exception
	 */
	public void setAlgorithmType(AlgorithmType algorithmType) {

		this.algorithmType = algorithmType;
	} // setAlgorithmType

} // Class RouteCalculationService
