/**
 * This file was auto-generated by mofcomp -j version 1.0.0 on Wed Jan 12
 * 09:21:06 CET 2011.
 */

package org.opennaas.extensions.router.model;

import java.io.*;
import java.lang.Exception;

/**
 * This Class contains accessor and mutator methods for all properties defined in the CIM class VLANEndpointSettingData as well as methods comparable
 * to the invokeMethods defined for this class. This Class implements the VLANEndpointSettingDataBean Interface. The CIM class VLANEndpointSettingData
 * is described as follows:
 * 
 * The VLAN configuration data for an endpoint. Note that certain properties only apply based on the value in the VLANEndpoint.
 * OperationalEndpointMode property. If it is set to trunking mode then NativeVLAN, PruneEligibleVLANList, DefaultVLAN and TrunkedVLANList are
 * applicable. If it is set to in access mode, then AccessVLAN is applicable. An instance of this class is associated to the endpoint to which it
 * applies using ElementSettingData.
 */
public class VLANEndpointSettingData extends SettingData implements
		Serializable {

	/**
	 * This constructor creates a VLANEndpointSettingDataBeanImpl Class which implements the VLANEndpointSettingDataBean Interface, and encapsulates
	 * the CIM class VLANEndpointSettingData in a Java Bean. The CIM class VLANEndpointSettingData is described as follows:
	 * 
	 * The VLAN configuration data for an endpoint. Note that certain properties only apply based on the value in the VLANEndpoint.
	 * OperationalEndpointMode property. If it is set to trunking mode then NativeVLAN, PruneEligibleVLANList, DefaultVLAN and TrunkedVLANList are
	 * applicable. If it is set to in access mode, then AccessVLAN is applicable. An instance of this class is associated to the endpoint to which it
	 * applies using ElementSettingData.
	 */
	public VLANEndpointSettingData() {
	};

	/**
	 * The following constants are defined for use with the ValueMap/Values qualified property pruneEligibleVLANList.
	 */
	private int[]	pruneEligibleVLANList;

	/**
	 * This method returns the VLANEndpointSettingData.pruneEligibleVLANList property value. This property is described as follows:
	 * 
	 * If a VLAN Id is part of this array, then the system MAY prune that VLAN on the related trunk endpoint/port. This property is applicable only
	 * when the endpoint is operating in trunking mode (determined by examining the OperationalEndpointMode property).
	 * 
	 * @return int[] current pruneEligibleVLANList property value
	 * @exception Exception
	 */
	public int[] getPruneEligibleVLANList() {

		return this.pruneEligibleVLANList;
	} // getPruneEligibleVLANList

	/**
	 * This method sets the VLANEndpointSettingData.pruneEligibleVLANList property value. This property is described as follows:
	 * 
	 * If a VLAN Id is part of this array, then the system MAY prune that VLAN on the related trunk endpoint/port. This property is applicable only
	 * when the endpoint is operating in trunking mode (determined by examining the OperationalEndpointMode property).
	 * 
	 * @param int[] new pruneEligibleVLANList property value
	 * @exception Exception
	 */
	public void setPruneEligibleVLANList(int[] pruneEligibleVLANList) {

		this.pruneEligibleVLANList = pruneEligibleVLANList;
	} // setPruneEligibleVLANList

	/**
	 * The following constants are defined for use with the ValueMap/Values qualified property nativeVLAN.
	 */
	private int	nativeVLAN;

	/**
	 * This method returns the VLANEndpointSettingData.nativeVLAN property value. This property is described as follows:
	 * 
	 * VLAN Id that is used to tag untagged traffic received on this trunk endpoint/port. This property is applicable only when the endpoint is
	 * operating in trunking mode (determined by examining the SwitchEndpointMode property).
	 * 
	 * @return int current nativeVLAN property value
	 * @exception Exception
	 */
	public int getNativeVLAN() {

		return this.nativeVLAN;
	} // getNativeVLAN

	/**
	 * This method sets the VLANEndpointSettingData.nativeVLAN property value. This property is described as follows:
	 * 
	 * VLAN Id that is used to tag untagged traffic received on this trunk endpoint/port. This property is applicable only when the endpoint is
	 * operating in trunking mode (determined by examining the SwitchEndpointMode property).
	 * 
	 * @param int new nativeVLAN property value
	 * @exception Exception
	 */
	public void setNativeVLAN(int nativeVLAN) {

		this.nativeVLAN = nativeVLAN;
	} // setNativeVLAN

	/**
	 * The following constants are defined for use with the ValueMap/Values qualified property defaultVLAN.
	 */
	private int	defaultVLAN;

	/**
	 * This method returns the VLANEndpointSettingData.defaultVLAN property value. This property is described as follows:
	 * 
	 * Default value for the native VLAN on this trunk endpoint/port. This property is applicable only when the endpoint is operating in trunking mode
	 * (determined by examining the OperationalEndpointMode property).
	 * 
	 * @return int current defaultVLAN property value
	 * @exception Exception
	 */
	public int getDefaultVLAN() {

		return this.defaultVLAN;
	} // getDefaultVLAN

	/**
	 * This method sets the VLANEndpointSettingData.defaultVLAN property value. This property is described as follows:
	 * 
	 * Default value for the native VLAN on this trunk endpoint/port. This property is applicable only when the endpoint is operating in trunking mode
	 * (determined by examining the OperationalEndpointMode property).
	 * 
	 * @param int new defaultVLAN property value
	 * @exception Exception
	 */
	public void setDefaultVLAN(int defaultVLAN) {

		this.defaultVLAN = defaultVLAN;
	} // setDefaultVLAN

	/**
	 * The following constants are defined for use with the ValueMap/Values qualified property trunkedVLANList.
	 */
	private int[]	trunkedVLANList;

	/**
	 * This method returns the VLANEndpointSettingData.trunkedVLANList property value. This property is described as follows:
	 * 
	 * If a VLAN Id is part of this array, then the system MAY trunk the traffic on the related endpoint/port. This property is applicable only when
	 * the endpoint is operating in trunking mode (determined by examining the OperationalEndpointMode property).
	 * 
	 * @return int[] current trunkedVLANList property value
	 * @exception Exception
	 */
	public int[] getTrunkedVLANList() {

		return this.trunkedVLANList;
	} // getTrunkedVLANList

	/**
	 * This method sets the VLANEndpointSettingData.trunkedVLANList property value. This property is described as follows:
	 * 
	 * If a VLAN Id is part of this array, then the system MAY trunk the traffic on the related endpoint/port. This property is applicable only when
	 * the endpoint is operating in trunking mode (determined by examining the OperationalEndpointMode property).
	 * 
	 * @param int[] new trunkedVLANList property value
	 * @exception Exception
	 */
	public void setTrunkedVLANList(int[] trunkedVLANList) {

		this.trunkedVLANList = trunkedVLANList;
	} // setTrunkedVLANList

	/**
	 * The following constants are defined for use with the ValueMap/Values qualified property accessVLAN.
	 */
	private int	accessVLAN;

	/**
	 * This method returns the VLANEndpointSettingData.accessVLAN property value. This property is described as follows:
	 * 
	 * The access VLAN for the referenced VLANEndpoint.
	 * 
	 * @return int current accessVLAN property value
	 * @exception Exception
	 */
	public int getAccessVLAN() {

		return this.accessVLAN;
	} // getAccessVLAN

	/**
	 * This method sets the VLANEndpointSettingData.accessVLAN property value. This property is described as follows:
	 * 
	 * The access VLAN for the referenced VLANEndpoint.
	 * 
	 * @param int new accessVLAN property value
	 * @exception Exception
	 */
	public void setAccessVLAN(int accessVLAN) {

		this.accessVLAN = accessVLAN;
	} // setAccessVLAN

} // Class VLANEndpointSettingData
